(*************************************************
TpvlOvcTCDateEdit is the link of a pvlDateedit to
an Orpheus Table Component.

This Source Code remains Copyrighted to
CopyRight (c) 1998 PA van Lonkhuyzen

It may be distributed/modified/used freely.

The Author may be contacted via
email peterv@global.co.za
post P A van Lonkhuyzen
     PO Box 1041
     Randpark Ridge
     2156
     South Africa
***************************************************)
{$D-,L-} {Remove if you wish to debug this code}
unit DateCell;
interface

uses
{$ifdef win32}
  Windows,
{$else}
WinProcs,
Wintypes,
{$endif}
  SysUtils, Messages,
  Graphics, Classes, Controls, Forms, StdCtrls,
  OvcData, OvcConst, OvcBase, OvcMisc,EdTool,pvldedit,
  OvcTCmmn, OvcTCell, OvcTGPns, OvcTable, OvcTCStr;

type
  TpvlOvcDateEditEdit = class(TpvlCustomDateEdit)
    protected
      FCell     : TOvcBaseTableCell;
      EditField : HWnd;
    protected
      procedure WMChar(var Msg : TWMKey); message WM_CHAR;
      procedure WMGetDlgCode(var Msg : TMessage); message WM_GETDLGCODE;
      procedure WMKeyDown(var Msg : TWMKey); message WM_KEYDOWN;
      procedure WMSetFocus(var Msg : TWMSetFocus); message WM_SETFOCUS;
    public
      property CellOwner : TOvcBaseTableCell read FCell write FCell;
  end;


  TpvlOvcTCCustomDateEdit = class(TOvcTCBaseString)
  private
    fDontWantFormEvent: TWantFormEvent;
    private
      fShowTodayButton: Boolean;
      fShowYearButtons: Boolean;
      fTodayHeading: String;
      fmin,fmax : TDateTime;
      fnullday,fnullmonth,fnullyear : Word;
      fminday,fminmonth,fminyear : Word;
      fmaxday,fmaxmonth,fmaxyear : Word;
      fDayHeadings : TStrings;
      fMonthHeading :String;
      fYearHeading : String;
      fStartOfWeek : TDayOfWeek;
      fQuickChangeType : TQuickChangeType;
      fQuickChangeWrap : Boolean;
      fusenulldate : Boolean;
      fnulldate : tdatetime;
      fWantFormEvent : TWantFormEvent;
      fSubAlign : TSubAlign;
      fEditFormat : TDateEditFormat;
      fEditFormatMask : String;
      FAutoAdvanceChar      : boolean;
      FAutoAdvanceLeftRight : boolean;
      FOnChange      : TNotifyEvent;
      fDisplayFormat : TDateDisplayFormat;
      fDisplayFormatMask : String;
      fminmaxhandler : TMinMaxhandler;
      fOnMinmaxError : TMinMaxDateEvent;
      fMinMaxString : String;
      FOnDateChange : TNotifyEvent;
      FColors : TPvlGridColors;
      fHighLightDays,
      fInvalidDays : TPvlDaySet;
      fCalFont : TFont;
      procedure loaded; override;
      function GetCellEditor : TControl; override;
      procedure tcPaint(TableCanvas : TCanvas;
                  const CellRect    : TRect;
                        RowNum      : TRowNum;
                        ColNum      : TColNum;
                  const CellAttr    : TOvcCellAttributes;
                        Data        : pointer); override;
      function getnullday : word;
      procedure setnullday(num : word);
      function getnullMonth : word;
      procedure setnullMonth(num : word);
      function getnullYear : word;
      procedure setnullYear(num : word);
      function getminday : word;
      procedure setminday(num : word);
      function getminMonth : word;
      procedure setminMonth(num : word);
      function getminYear : word;
      procedure setminYear(num : word);
      function getmaxday : word;
      procedure setmaxday(num : word);
      function getmaxMonth : word;
      procedure setmaxMonth(num : word);
      function getmaxYear : word;
      procedure setmaxYear(num : word);
      procedure SetDayHeadings(s: TStrings);
      procedure SetCalFont(f: TFont);
      property AutoAdvanceChar : boolean read FAutoAdvanceChar write FAutoAdvanceChar;
      property AutoAdvanceLeftRight : boolean read FAutoAdvanceLeftRight write FAutoAdvanceLeftRight;
      property SubAlign : TSubalign read fsubalign write fsubalign;
      property OnChange : TNotifyEvent read FOnChange write FOnChange;
      Property DisplayFormat : TDateDisplayFormat Read fDisplayFormat Write fDisplayFormat Default dfLong;
      Property DisplayFormatMask : String Read fDisplayFormatMask Write fDisplayFormatMask;
      Property MinMaxHandler : TMinMaxHandler read fMinMaxHandler write fMinMaxHandler;
      Property OnMinmaxError : TMinMaxDateEvent  Read fOnMinMaxError write fOnMinMaxError;
      Property MinMaxString : String read fMinMaxString write fMinMaxString;
      Property OnWantForm : TWantFormEvent Read fWantFormEvent Write fWantFormEvent;
      property NullDay : word read getNullday write setNullday stored fusenulldate;
      property NullMonth : word read getNullmonth write setNullMonth stored fusenulldate;
      property NullYear : word read getNullYear write setNullYear stored fusenulldate;
      property MinDay : word read getMinday write setMinday;
      property MinMonth : word read getMinmonth write setMinMonth;
      property MinYear : word read getMinYear write setMinYear;
      property MaxDay : word read getMaxday write setMaxday;
      property MaxMonth : word read getMaxmonth write setMaxMonth;
      property MaxYear : word read getMaxYear write setMaxYear;
      Property Min: TDateTime read fmin write fMin;
      Property Max: TDateTime read fmax write fMax;
      Property DayHeadings : TStrings read fDayHeadings write SetDayHeadings;
      Property UseNullDate : Boolean read fUseNullDate write fUseNulldate;
      property Nulldate : TDateTime read fNullDate write fNullDate;
      Property Monthheading : String read fMonthHeading write fMonthHeading;
      Property Yearheading : String read fYearHeading write fYearHeading;
      property StartofWeek : TDayOfWeek read fstartofweek write fstartofweek;
      property QuickChangeType : TQuickChangeType read fQuickChangeType write fQuickChangeType;
      property QuickChangeWrap : Boolean read fQuickChangeWrap write fQuickChangeWrap;
      Property EditFormat : TDateEditFormat Read fEditFormat Write fEditFormat Default dfShort;
      Property EditFormatMask : String Read fEditFormatMask Write fEditFormatMask;
      property CalendarFont : TFont read fCalfont write SetCalFont;
      Property OnDateChange : TNotifyEvent Read fOnDateChange Write fOnDateChange;
      Property CalendarColors : TPvlGridColors read fColors write fColors;
      Property HighlightDays : TPvlDaySet read fHighLightDays write fHighLightDays default [Sun,Sat];
      Property InvalidDays : TPvlDaySet read fInvalidDays write fInvalidDays;
      property TodayHeading : String read fTodayHeading write fTodayHeading;
      property ShowTodayButton : Boolean read fShowTodayButton write fShowtodayButton;
      property ShowYearButtons : Boolean read fShowYearButtons write fShowYearButtons Default True;
      Property OnBeforeSubFormFree : TWantFormEvent Read fDontWantFormEvent Write fDontWantFormEvent;
     public
      FEditor          : TpvlOvcDateEditEdit;
      constructor Create(AOwner : TComponent); override;
      destructor Destroy; override;
      function  EditHandle : THandle; override;
      procedure EditHide; override;
      procedure EditMove(CellRect : TRect); override;
      procedure SaveEditedData(Data : pointer); override;
      procedure StartEditing(RowNum : TRowNum; ColNum : TColNum;
                             CellRect : TRect;
                       const CellAttr : TOvcCellAttributes;
                             CellStyle: TOvcTblEditorStyle;
                             Data : pointer); override;
      procedure StopEditing(SaveValue : boolean;
                            Data : pointer); override;
  end;

  TpvlOvcTCDateEdit = class(TpvlOvcTCCustomDateEdit)
  public
    property nulldate;
    property min;
    property max;
  published
      Property OnDateChange;
      Property CalendarColors;
      Property HighlightDays;
      Property InvalidDays;
      property Calendarfont;
      property StartofWeek;
      Property DayHeadings;
      property NullDay;
      property NullMonth;
      property NullYear;
      property MinDay;
      property MinMonth;
      property MinYear;
      property MaxDay;
      property MaxMonth;
      property MaxYear;
      Property OnWantForm;
      Property DisplayFormat;
      Property DisplayFormatMask;
      property AcceptActivationClick;
      property Access;
      property Adjust;
      property AutoAdvanceChar;
      property AutoAdvanceLeftRight;
      property Color;
      property Font;
      property Hint;
      property ShowHint;
      property Margin;
      Property SubAlign;
      property Table;
      property TableColor;
      property TableFont;
      property TextHiColor;
      property TextStyle;
      property OnChange;
      property OnClick;
      property OnDblClick;
      property OnDragDrop;
      property OnDragOver;
      property OnEndDrag;
      property OnEnter;
      property OnExit;
      property OnKeyDown;
      property OnKeyPress;
      property OnKeyUp;
      property OnMouseDown;
      property OnMouseMove;
      property OnMouseUp;
      property OnOwnerDraw;
      Property MinMaxHandler;
      Property OnMinmaxError;
      Property MinMaxString;
      property Usenulldate;
      Property Monthheading;
      Property Yearheading;
      property QuickChangeType;
      property QuickChangeWrap;
      Property EditFormat;
      Property EditFormatMask;
      property TodayHeading;
      property ShowTodayButton;
      property ShowYearButtons;
      Property OnBeforeSubFormFree;
  end;

implementation
Type PDateTime = ^TDateTime;
{===TpvlOvcDateEditEdit================================================}
{--------}
procedure TpvlOvcDateEditEdit.WMChar(var Msg : TWMKey);
var
  CurText : string;
begin
  inherited;
  if TpvlOvcTCCustomDateEdit(CellOwner).AutoAdvanceChar then
  begin
    CurText := Text;
    if (length(CurText) >= MaxLength) then
    begin
      FillChar(Msg, sizeof(Msg), 0);
      with Msg do
      begin
        Msg := WM_KEYDOWN;
        CharCode := VK_RIGHT;
      end;
      CellOwner.SendKeyToTable(Msg);
    end;
   end;
 end;
{--------}
procedure TpvlOvcDateEditEdit.WMGetDlgCode(var Msg : TMessage);
begin
  inherited;
  if CellOwner.TableWantsTab then
      Msg.Result := Msg.Result or DLGC_WANTTAB;
end;
{--------}
procedure TpvlOvcDateEditEdit.WMKeyDown(var Msg : TWMKey);
var
    GridReply    : TOvcTblKeyNeeds;
    GridUsedIt   : boolean;
begin
  GridUsedIt := false;
  GridReply := otkDontCare;
  if (CellOwner <> nil) then
    GridReply := CellOwner.FilterTableKey(Msg);
  case GridReply of
    otkMustHave : GridUsedIt := true;
    otkWouldLike : begin
          gridusedit := not Button.enabled;
          if not gridusedit then
            case msg.CharCode of
    vk_delete : ;
    vk_left : Gridusedit:=(getselstart=0) and (getsellength=0);
    vk_right : GridUsedIt := (GetSelStart>=length(text)) and (getsellength=0);
    vk_home:;
    vk_end:;
    ord('+'),ord('-') : gridusedit:=(QuickChangeType=qcNone);
    ord(0)..ord(9):;
            else
              gridusedit:=true;
           end;
        end;
  end;
  if GridUsedIt then
    CellOwner.SendKeyToTable(Msg)
  else
    inherited;
end;
{--------}
procedure TpvlOvcDateEditEdit.WMSetFocus(var Msg : TWMSetFocus);
begin
  inherited;
  CellOwner.PostMessageToTable(ctim_SetFocus, Msg.FocusedWnd, 0);
end;
{====================================================================}


{===TpvlOvcTCCustomDateEdit=============================================}
procedure TPvlOvcTcCustomDateEdit.SetCalFont(f: TFont);
begin
  fCalFont.Assign(f);
end;


procedure TPvlOvcTcCustomDateEdit.SetDayHeadings(s: TStrings);
begin
  fDayHeadings.Assign(s);
end;

procedure TPvlOvcTcCustomDateEdit.Loaded;
begin
  inherited Loaded;
  if fusenulldate then
    fnulldate:=encodedate(fnullyear,fnullmonth,fnullday);
  try
    if fminday<>0 then
    fMin:=encodedate(fMinyear,fMinmonth,fMinday);
  except
    fmin:=0;
  end;
  try
    if fmaxday<>0 then
    fMax:=encodedate(fMaxyear,fMaxmonth,fMaxday);
  except
    fmax:=0;
  end;
end;

constructor TpvlOvcTCCustomDateEdit.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FAcceptActivationClick := true;
  fshowyearbuttons:=True;
  fDisplayFormat:=dflong;
{$ifndef win32}
  fnullmonth:=12;
  fnullyear:=1899;
  fnullday:=30;
  fmaxmonth:=12;
  fmaxyear:=1899;
  fmaxday:=30;
  fminmonth:=12;
  fminyear:=1899;
  fminday:=30;
{$endif}
  fHighLightDays:=[Sat,Sun];
  fColors := TPvlGridColors.Create;
  fcalfont:=TFont.Create;
  fcalfont.Name:='MS Sans Serif';
  fcalfont.size:=8;
  feditformat:=dfshort;
  fdayheadings:=Tstringlist.create;
end;
{--------}
destructor TpvlOvcTCCustomDateEdit.Destroy;
begin
  FCalFont.Free;
  fDayheadings.free;
  fColors.free;
  inherited Destroy;
end;
{--------}
function TPvlOvcTcCustomDateEdit.getnullday : word;
var d,m,y : word;
begin
  decodedate(fnulldate,y,m,d);
  result:=d;
end;

procedure TPvlOvcTcCustomDateEdit.setNullday(num : word);
var d,m,y : word;
begin
  if csloading in componentstate then
    fnullday:=num
  else
  try
  decodedate(fnulldate,y,m,d);
  fnulldate:=encodedate(y,m,num);
  except
  end;
end;

function TPvlOvcTcCustomDateEdit.getNullMonth : word;
var d,m,y : word;
begin
  decodedate(fNulldate,y,m,d);
  result:=m;
end;

procedure TPvlOvcTcCustomDateEdit.setNullMonth(num : word);
var d,m,y : word;
begin
  if csloading in componentstate then
    fnullmonth:=num
  else
  try
    decodedate(fnulldate,y,m,d);
    fnulldate:=encodedate(y,num,d);
  except
  end;
end;

function TPvlOvcTcCustomDateEdit.getnullYear : word;
var d,m,y : word;
begin
  decodedate(fnulldate,y,m,d);
  result:=y;
end;

procedure TPvlOvcTcCustomDateEdit.setnullYear(num : word);
var d,m,y : word;
begin
  if csloading in componentstate then
    fnullyear:=num
  else
  try
    decodedate(fnulldate,y,m,d);
    fnulldate:=encodedate(num,m,d);
  except
  end;
end;

function TPvlOvcTcCustomDateEdit.getMinday : word;
var d,m,y : word;
begin
  decodedate(fMin,y,m,d);
  result:=d;
end;

procedure TPvlOvcTcCustomDateEdit.setMinday(num : word);
var d,m,y : word;
begin
  if csloading in componentstate then
    fMinday:=num
  else
  try
  decodedate(fMin,y,m,d);
  Min:=encodedate(y,m,num);
  except
  end;
end;

function TPvlOvcTcCustomDateEdit.getMinMonth : word;
var d,m,y : word;
begin
  decodedate(fMin,y,m,d);
  result:=m;
end;

procedure TPvlOvcTcCustomDateEdit.setMinMonth(num : word);
var d,m,y : word;
begin
  if csloading in componentstate then
    fMinmonth:=num
  else
  try
    decodedate(fMin,y,m,d);
    Min:=encodedate(y,num,d);
  except
  end;
end;

function TPvlOvcTcCustomDateEdit.getMinYear : word;
var d,m,y : word;
begin
  decodedate(fMin,y,m,d);
  result:=y;
end;

procedure TPvlOvcTcCustomDateEdit.setMinYear(num : word);
var d,m,y : word;
begin
  if csloading in componentstate then
    fMinyear:=num
  else
  try
    decodedate(fMin,y,m,d);
    Min:=encodedate(num,m,d);
  except
  end;
end;

function TPvlOvcTcCustomDateEdit.getMaxday : word;
var d,m,y : word;
begin
  decodedate(fMax,y,m,d);
  result:=d;
end;

procedure TPvlOvcTcCustomDateEdit.setMaxday(num : word);
var d,m,y : word;
begin
  if csloading in componentstate then
    fMaxday:=num
  else
  try
  decodedate(fMax,y,m,d);
  Max:=encodedate(y,m,num);
  except
  end;
end;

function TPvlOvcTcCustomDateEdit.getMaxMonth : word;
var d,m,y : word;
begin
  decodedate(fMax,y,m,d);
  result:=m;
end;

procedure TPvlOvcTcCustomDateEdit.setMaxMonth(num : word);
var d,m,y : word;
begin
  if csloading in componentstate then
    fMaxmonth:=num
  else
  try
    decodedate(fMax,y,m,d);
    Max:=encodedate(y,num,d);
  except
  end;
end;

function TPvlOvcTcCustomDateEdit.getMaxYear : word;
var d,m,y : word;
begin
  decodedate(fMax,y,m,d);
  result:=y;
end;

procedure TPvlOvcTcCustomDateEdit.setMaxYear(num : word);
var d,m,y : word;
begin
  if csloading in componentstate then
    fMaxyear:=num
  else
  try
    decodedate(fMax,y,m,d);
    Max:=encodedate(num,m,d);
  except
  end;
end;


function TpvlOvcTCCustomDateEdit.EditHandle : THandle;
begin
  if Assigned(FEditor) then
    Result := FEditor.Handle
  else
    Result := 0;
 end;
{--------}
procedure TpvlOvcTCCustomDateEdit.EditHide;
begin
  if Assigned(FEditor) then
    FEditor.visible:=false;
end;
{--------}
procedure TpvlOvcTCCustomDateEdit.EditMove(CellRect : TRect);
begin
  FEditor.boundsrect:=Cellrect;
  FEditor.visible:=True;
end;
{--------}
function TpvlOvcTCCustomDateEdit.GetCellEditor : TControl;
begin
  Result := FEditor;
end;
{--------}
procedure TpvlOvcTCCustomDateEdit.tcPaint(TableCanvas : TCanvas;
                                 const CellRect    : TRect;
                                       RowNum      : TRowNum;
                                       ColNum      : TColNum;
                                 const CellAttr    : TOvcCellAttributes;
                                       Data        : pointer);
  var
    Value : PDateTime absolute Data;
    S         : ShortString;
  begin
    {If the cell is invisible let the ancestor to all the work}
    if (CellAttr.caAccess = otxInvisible) then
      begin
        inherited tcPaint(TableCanvas, CellRect, RowNum, ColNum, CellAttr, nil);
        Exit;
      end;
    S := '';
    if (Data <> nil) then
      begin
        if not fusenulldate or (int(value^)<>int(fnulldate)) then
          case fDisplayFormat of
           dfshort : s:=formatdatetime('ddddd',value^);
           dflong : s:=formatdatetime('dddddd',value^);
           else
             s:=formatdatetime(fdisplayformatmask,value^);
          end
        else
          s:='';
      end
    else if (csDesigning in ComponentState) then
      S := 'Date';
    inherited tcPaint(TableCanvas, CellRect, RowNum, ColNum, CellAttr, @s);

  end;
{--------}
procedure TpvlOvcTCCustomDateEdit.SaveEditedData(Data : pointer);
  var
    Value : PDateTime absolute Data;
  begin
    if Assigned(Data) then
      begin
        Value^ := FEditor.Date;
      end;
  end;
{--------}
{--------}
procedure TpvlOvcTCCustomDateEdit.StartEditing(RowNum : TRowNum; ColNum : TColNum;
                                           CellRect : TRect;
                                     const CellAttr : TOvcCellAttributes;
                                           CellStyle: TOvcTblEditorStyle;
                                           Data : pointer);
  var
    OrgValue : PDateTime absolute Data;
  begin
    FEditor := TpvlOvcDateEditEdit.Create(FTable);
    with FEditor do
      begin
        OnDateChange:=fOnDateChange;
{//Todo Add an Assign To TpvlCalendarcolors;}
        CalendarColors.TodayColor:=fColors.TodayColor;
        CalendarColors.NormalColor:=fColors.NormalColor;
        CalendarColors.ShowToday:=fColors.ShowToday;
        CalendarColors.InvalidColor:=fColors.InvalidColor;
        CalendarColors.HighLightColor:=fColors.HighLightColor;
        CalendarColors.CalColor:=fColors.CalColor;
        TodayHeading := fTodayHeading;
        ShowTodayButton := fShowTodayButton;
        ShowYearButtons := fShowYearButtons;
        HighlightDays:=fHighlightDays;
        InvalidDays:=fInvalidDays;
        Calendarfont:=fcalfont;
        QuickChangeType:=fQuickChangeType;
        QuickChangeWrap:=fQuickChangeWrap;
        EditFormat:=fEditFormat;
        EditFormatMask:=fEditFormatMask;
        StartofWeek:=fStartOfWeek;
        dayheadings:=fdayheadings;
        min:=fmin;
        max:=fmax;
        nulldate:=fnulldate;
        usenulldate:=fusenulldate;
{        OnDoneValue:=FOnDoneValue;}
        MinMaxHandler:=fMinMaxHandler;
        OnMinmaxError:=fOnMinMaxError;
        MinMaxString:=fMinMaxString;
        SubAlign:=fSubAlign;
        Displayformat:=fDisplayformat;
        Displayformatmask:=fDisplayFormatMask;
        Monthheading := fMonthHeading;
        Yearheading := fYearHeading;
        Color := CellAttr.caColor;
        Ctl3D := false;
        case CellStyle of
          tes3D     : Ctl3D := true;
        end;{case}
        FEditor.boundsrect:=CellRect;
        Font := CellAttr.caFont;
        Font.Color := CellAttr.caFontColor;
        Hint := fHint;
        ShowHint := fShowHint;
        Visible := true;
        CellOwner := Self;
        TabStop := false;
        Parent := FTable;
        if (Ftable<>nil) and (fTable.controller<>nil) then
          FEditor.ImpliedCenturyStart:=FTable.Controller.Epoch;
        Date:=OrgValue^;
        Onwantform:=self.onwantform;
        OnBeforeSubFormFree := self.OnBeforeSubFormFree;
        OnChange := Self.OnChange;
        OnClick := Self.OnClick;
        OnDblClick := Self.OnDblClick;
        OnDragDrop := Self.OnDragDrop;
        OnDragOver := Self.OnDragOver;
        OnEndDrag := Self.OnEndDrag;
        OnEnter := Self.OnEnter;
        OnExit := Self.OnExit;
        OnKeyDown := Self.OnKeyDown;
        OnKeyPress := Self.OnKeyPress;
        OnKeyUp := Self.OnKeyUp;
        OnMouseDown := Self.OnMouseDown;
        OnMouseMove := Self.OnMouseMove;
        OnMouseUp := Self.OnMouseUp;
      end;
  end;
{--------}
procedure TpvlOvcTCCustomDateEdit.StopEditing(SaveValue : boolean;
                                          Data : pointer);
  var
    Value :PDateTime absolute Data;
  begin
    if SaveValue and Assigned(Data) then
      begin
        Value^ := FEditor.Date;
      end;
    FEditor.free;
    FEditor := nil;
  end;
{====================================================================}

end.
