(*************************************************
TpvlOvcTCMoreEdit is the link of a pvlMoreedit to
an Orpheus Table Component.

This Source Code remains Copyrighted to
CopyRight (c) 1998,99 PA van Lonkhuyzen

It may be distributed/modified/used freely.

The Author may be contacted via
email peterv@global.co.za
post P A van Lonkhuyzen
     PO Box 1041
     Randpark Ridge
     2156
     South Africa
***************************************************)
{$D-,L-} {Remove if you wish to debug this code}
unit Morecell;
interface

uses
{$ifdef win32}
  Windows,
{$else}
WinProcs,
Wintypes,
{$endif}
  SysUtils, Messages,
  Graphics, Classes, Controls, Forms, StdCtrls,
  OvcData, OvcConst, OvcBase, OvcMisc,EdTool,pvldedit,
  OvcTCmmn, OvcTCell, OvcTGPns, OvcTable, OvcTCStr;

type
  TpvlOvcMoreEditEdit = class(TpvlCustomMoreEdit)
    protected
      FCell     : TOvcBaseTableCell;
      EditField : HWnd;
    protected
      procedure WMChar(var Msg : TWMKey); message WM_CHAR;
      procedure WMGetDlgCode(var Msg : TMessage); message WM_GETDLGCODE;
      procedure WMKeyDown(var Msg : TWMKey); message WM_KEYDOWN;
      procedure WMSetFocus(var Msg : TWMSetFocus); message WM_SETFOCUS;
    public
      property CellOwner : TOvcBaseTableCell read FCell write FCell;
  end;


  TpvlOvcTCCustomMoreEdit = class(TOvcTCBaseString)
    protected {private}
      FButtonOnly: Boolean;
      fDontWantFormEvent: TWantFormEvent;
      fWantFormEvent : TWantFormEvent;
      fSubAlign : TSubAlign;
      fMaxLength : Integer;
      FEditor          : TpvlOvcMoreEditEdit;
      FAutoAdvanceChar      : boolean;
      FAutoAdvanceLeftRight : boolean;
      FOnChange      : TNotifyEvent;
      fOnButtonClick : TNotifyEvent;
      fOnRButtonClick : TNotifyEvent;
      fGlyph : TBitmap;
      procedure SetButtonOnly(const Value: Boolean);
      procedure loaded; override;
      function GetCellEditor : TControl; override;
      procedure tcPaint(TableCanvas : TCanvas;
                  const CellRect    : TRect;
                        RowNum      : TRowNum;
                        ColNum      : TColNum;
                  const CellAttr    : TOvcCellAttributes;
                        Data        : pointer); override;
      property AutoAdvanceChar : boolean read FAutoAdvanceChar write FAutoAdvanceChar;
      property AutoAdvanceLeftRight : boolean read FAutoAdvanceLeftRight write FAutoAdvanceLeftRight;
      property SubAlign : TSubalign read fsubalign write fsubalign;
      property OnChange : TNotifyEvent read FOnChange write FOnChange;
      Property OnWantForm : TWantFormEvent Read fWantFormEvent Write fWantFormEvent;
      Property OnBeforeSubFormFree : TWantFormEvent Read fDontWantFormEvent Write fDontWantFormEvent;
      Property Glyph : TBitmap Read fGlyph Write fGlyph;
      Property OnRButtonClick:TNotifyEvent read fOnRButtonClick write fOnRButtonClick;
      Property OnButtonClick:TNotifyEvent read fOnButtonClick write fOnButtonClick;
      property MaxLength:Integer read fMaxlength write fMaxLength;
      property ButtonOnly : Boolean read FButtonOnly write SetButtonOnly;
     public
      constructor Create(AOwner : TComponent); override;
      destructor Destroy; override;
      function  EditHandle : THandle; override;
      procedure EditHide; override;
      procedure EditMove(CellRect : TRect); override;
      procedure SaveEditedData(Data : pointer); override;
      procedure StartEditing(RowNum : TRowNum; ColNum : TColNum;
                             CellRect : TRect;
                       const CellAttr : TOvcCellAttributes;
                             CellStyle: TOvcTblEditorStyle;
                             Data : pointer); override;
      procedure StopEditing(SaveValue : boolean;
                            Data : pointer); override;
  end;

  TpvlOvcTCMoreEdit = class(TpvlOvcTCCustomMoreEdit)
  public
      Property Editor : TpvlOvcMoreEditEdit read fEditor;
  published
      Property Glyph;
      Property OnRButtonClick;
      Property OnButtonClick;
      Property OnBeforeSubFormFree;
      Property OnWantForm;
      property AcceptActivationClick;
      property Access;
      property Adjust;
      property AutoAdvanceChar;
      property AutoAdvanceLeftRight;
      property Color;
      property Font;
      property Hint;
      property ShowHint;
      property Margin;
      Property SubAlign;
      property Table;
      property TableColor;
      property TableFont;
      property TextHiColor;
      property TextStyle;
      property OnChange;
      property OnClick;
      property OnDblClick;
      property OnDragDrop;
      property OnDragOver;
      property OnEndDrag;
      property OnEnter;
      property OnExit;
      property OnKeyDown;
      property OnKeyPress;
      property OnKeyUp;
      property OnMouseDown;
      property OnMouseMove;
      property OnMouseUp;
      property OnOwnerDraw;
      property MaxLength;
      property ButtonOnly;
  end;

implementation
Type PDateTime = ^TDateTime;
{===TpvlOvcMoreEditEdit================================================}
{--------}
procedure TpvlOvcMoreEditEdit.WMChar(var Msg : TWMKey);
var
  CurText : string;
begin
  inherited;
  if TpvlOvcTCCustomMoreEdit(CellOwner).AutoAdvanceChar then
  begin
    CurText := Text;
    if (length(CurText) >= MaxLength) then
    begin
      FillChar(Msg, sizeof(Msg), 0);
      with Msg do
      begin
        Msg := WM_KEYDOWN;
        CharCode := VK_RIGHT;
      end;
      CellOwner.SendKeyToTable(Msg);
    end;
   end;
 end;
{--------}
procedure TpvlOvcMoreEditEdit.WMGetDlgCode(var Msg : TMessage);
begin
  inherited;
  if CellOwner.TableWantsTab then
      Msg.Result := Msg.Result or DLGC_WANTTAB;
end;
{--------}
procedure TpvlOvcMoreEditEdit.WMKeyDown(var Msg : TWMKey);
var
    GridReply    : TOvcTblKeyNeeds;
    GridUsedIt   : boolean;
begin
  GridUsedIt := false;
  GridReply := otkDontCare;
  if (CellOwner <> nil) then
    GridReply := CellOwner.FilterTableKey(Msg);
  case GridReply of
    otkMustHave : GridUsedIt := true;
    otkWouldLike : case msg.CharCode of
                      vk_left : Gridusedit:=(selstart=0) and (sellength=0);
                      vk_right : GridUsedIt := (SelStart>=length(text)) and (sellength=0);
                     else gridusedit := True;
                   end;
  end;
  if GridUsedIt then
    CellOwner.SendKeyToTable(Msg)
  else
    inherited;
end;
{--------}
procedure TpvlOvcMoreEditEdit.WMSetFocus(var Msg : TWMSetFocus);
begin
  inherited;
  CellOwner.PostMessageToTable(ctim_SetFocus, Msg.FocusedWnd, 0);
end;
{====================================================================}


{===TpvlOvcTCCustomMoreEdit=============================================}
procedure TPvlOvcTcCustomMoreEdit.Loaded;
begin
  inherited Loaded;
end;

constructor TpvlOvcTCCustomMoreEdit.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FAcceptActivationClick := true;
end;
{--------}
destructor TpvlOvcTCCustomMoreEdit.Destroy;
begin
  inherited Destroy;
end;
{--------}

function TpvlOvcTCCustomMoreEdit.EditHandle : THandle;
begin
  if Assigned(FEditor) then
    Result := FEditor.Handle
  else
    Result := 0;
 end;
{--------}
procedure TpvlOvcTCCustomMoreEdit.EditHide;
begin
  if Assigned(FEditor) then
    FEditor.visible:=false;
end;
{--------}
procedure TpvlOvcTCCustomMoreEdit.EditMove(CellRect : TRect);
begin
  FEditor.boundsrect:=Cellrect;
  FEditor.visible:=True;
end;
{--------}
function TpvlOvcTCCustomMoreEdit.GetCellEditor : TControl;
begin
  Result := FEditor;
end;
{--------}
procedure TpvlOvcTCCustomMoreEdit.tcPaint(TableCanvas : TCanvas;
                                 const CellRect    : TRect;
                                       RowNum      : TRowNum;
                                       ColNum      : TColNum;
                                 const CellAttr    : TOvcCellAttributes;
                                       Data        : pointer);
  var
    Value : PShortString absolute Data;
    S         : ShortString;
  begin
    {If the cell is invisible let the ancestor to all the work}
    if (CellAttr.caAccess = otxInvisible) or (data=nil) then
      begin
        inherited tcPaint(TableCanvas, CellRect, RowNum, ColNum, CellAttr, nil);
        Exit;
      end;
    S := '';
    if (Data <> nil) then
    begin
      s:=value^;
    end
    else if (csDesigning in ComponentState) then
      S := 'MoreEdit';
    inherited tcPaint(TableCanvas, CellRect, RowNum, ColNum, CellAttr, @s);
  end;
{--------}
procedure TpvlOvcTCCustomMoreEdit.SaveEditedData(Data : pointer);
  var
    Value : PShortString absolute Data;
  begin
    if Assigned(Data) then
      begin
        Value^ := FEditor.Text;
      end;
  end;
{--------}
{--------}
procedure TpvlOvcTCCustomMoreEdit.StartEditing(RowNum : TRowNum; ColNum : TColNum;
                                           CellRect : TRect;
                                     const CellAttr : TOvcCellAttributes;
                                           CellStyle: TOvcTblEditorStyle;
                                           Data : pointer);
  var
    OrgValue : PShortString absolute Data;
  begin
    if data=nil then
      exit;
    FEditor := TpvlOvcMoreEditEdit.Create(FTable);
    with FEditor do
      begin
{//Todo Add an Assign To TpvlCalendarcolors;}
        Buttononly:=fbuttononly;
        SubAlign:=fSubAlign;
        Color := CellAttr.caColor;
        Ctl3D := false;
        case CellStyle of
          tes3D     : Ctl3D := true;
        end;{case}
        FEditor.boundsrect:=CellRect;
        Font := CellAttr.caFont;
        Font.Color := CellAttr.caFontColor;
        Hint := fHint;
        ShowHint := fShowHint;
        Visible := true;
        CellOwner := Self;
        TabStop := false;
        Parent := FTable;
        Text:=OrgValue^;
        maxlength:=self.maxlength;
        Onwantform:=self.onwantform;
        OnBeforeSubFormFree := self.OnBeforeSubFormFree;
        Glyph := self.glyph;
        OnRButtonClick:=self.OnRButtonClick;
        OnButtonClick:=self.OnButtonClick;
        OnChange := Self.OnChange;
        OnClick := Self.OnClick;
        OnDblClick := Self.OnDblClick;
        OnDragDrop := Self.OnDragDrop;
        OnDragOver := Self.OnDragOver;
        OnEndDrag := Self.OnEndDrag;
        OnEnter := Self.OnEnter;
        OnExit := Self.OnExit;
        OnKeyDown := Self.OnKeyDown;
        OnKeyPress := Self.OnKeyPress;
        OnKeyUp := Self.OnKeyUp;
        OnMouseDown := Self.OnMouseDown;
        OnMouseMove := Self.OnMouseMove;
        OnMouseUp := Self.OnMouseUp;
      end;
  end;
{--------}
procedure TpvlOvcTCCustomMoreEdit.StopEditing(SaveValue : boolean;
                                          Data : pointer);
  var
    Value :PShortString absolute Data;
  begin
    if SaveValue and Assigned(Data) then
      begin
        Value^ := FEditor.Text;
      end;
    FEditor.free;
    FEditor := nil;
  end;
{====================================================================}

procedure TpvlOvcTCCustomMoreEdit.SetButtonOnly(const Value: Boolean);
begin
  FButtonOnly := Value;
  if feditor<>nil then
    feditor.buttononly:=value;
end;

end.
